USE TPCH

-- 建表
IF OBJECT_ID('region', 'U') IS NULL
  CREATE TABLE region (
    regionkey INTEGER PRIMARY KEY,
    name nCHAR(25),
    comment nvarchar(152)
  )

IF OBJECT_ID('nation', 'U') IS NULL
  CREATE TABLE nation (
    nationkey INTEGER PRIMARY KEY,
    name nCHAR(25),
    regionkey INTEGER REFERENCES Region(regionkey),
    comment nVARCHAR(152)
  )

IF OBJECT_ID('supplier', 'U') IS NULL
  CREATE TABLE supplier (
    suppkey INTEGER PRIMARY KEY,
    name nCHAR(25),
    address nVARCHAR(40),
    nationkey INTEGER REFERENCES Nation(nationkey),
    phone nCHAR(15),
    acctbal REAL,
    comment nVARCHAR(152)
  )

IF OBJECT_ID('part', 'U') IS NULL
  CREATE TABLE part (
    partkey INTEGER PRIMARY KEY,
    name nVARCHAR(55),
    mfgr nCHAR(25),
    brand nCHAR(10),
    type nVARCHAR(25),
    size INTEGER,
    container nCHAR(10),
    retailprice REAL,
    comment nVARCHAR(23)
  )


IF OBJECT_ID('partsupp', 'U') IS NULL
  CREATE TABLE partsupp (
    partkey INTEGER REFERENCES Part(partkey),
    suppkey INTEGER REFERENCES Supplier(suppkey),
    availqty INTEGER,
    supplycost REAL,
    comment nVARCHAR(199),
    PRIMARY KEY(partkey,suppkey)
  )

IF OBJECT_ID('customer', 'U') IS NULL
  CREATE TABLE customer (
    custkey INTEGER PRIMARY KEY,
    name nVARCHAR(25),
    address nVARCHAR(40),
    nationkey INTEGER REFERENCES Nation(nationkey),
    phone nCHAR(15),
    acctbal REAL,
    mktsegment nCHAR(10),
    comment nVARCHAR(17)
  )


IF OBJECT_ID('orders', 'U') IS NULL
  CREATE TABLE orders (
    orderkey INTEGER PRIMARY KEY,
    custkey INTEGER REFERENCES Customer(custkey),
    orderstatus CHAR(1),
    totalprice REAL,
    orderdate DATE,
    orderpriority nCHAR(15),
    clert nCHAR(15),
    shippriority INTEGER,
    comment nVARCHAR(79)                                           /* totalprice = SUM(Lineitem.extendedprice*(1-Lineitem.discount)*(1+Lineitem.tax)) */
  )

IF OBJECT_ID('lineitem', 'U') IS NULL
  CREATE TABLE lineitem (
    orderkey INTEGER,
    partkey INTEGER,
    suppkey INTEGER,
    linenumber INTEGER,
    quantity REAL,
    extendedprice REAL,
    discount REAL,
    tax REAL,
    returnflag CHAR(1),
    linestatus CHAR(1),
    shipdate DATE,
    commitdate DATE,
    receipdate DATE,
    shipinstruct nCHAR(25),
    shipmodel nCHAR(10),
    comment nVARCHAR(44),
    -- PRIMARY KEY(orderkey, linenumber),
    -- FOREIGN KEY(partkey,suppkey) REFERENCES PartSupp(partkey,suppkey)          /* extendedprice = quantity*Part.retailprice */
  )

-- 插入数据
-- region
-- regionkey, name, comment
INSERT INTO region VALUES (1, N'亚洲', N'亚洲地区')
INSERT INTO region VALUES (2, N'欧洲', N'欧洲地区')
INSERT INTO region VALUES (3, N'北美洲', N'北美洲地区')

-- nation
-- nationkey，name，regionkey，comment
INSERT INTO nation VALUES (1, N'中国', 1, N'中华人民共和国')
INSERT INTO nation VALUES (2, N'英国', 2, N'大不列颠及北爱尔兰联合王国')
INSERT INTO nation VALUES (3, N'美国', 3, N'美利坚合众国')
INSERT INTO nation VALUES (4, N'日本', 1, N'日本国')
INSERT INTO nation VALUES (5, N'德国', 2, N'德意志联邦共和国')
INSERT INTO nation VALUES (6, N'加拿大', 3, N'加拿大')

-- supplier
-- suppkey，name，address，nationkey，phone，acctbal，comment
INSERT INTO supplier VALUES (1, N'奇瑞', N'中国芜湖', 1, '010-111111111', 2500000.0, N'好车不贵')
INSERT INTO supplier VALUES (2, N'吉利', N'中国台州', 1, '010-222222222', 2000000.0, N'让世界充满吉利')
INSERT INTO supplier VALUES (3, N'比亚迪', N'中国深圳', 1, '010-333333333', 3225000.0, N'成就你的梦想')
INSERT INTO supplier VALUES (4, N'爱信', N'日本', 4, '444-11223331', 225000.0, N'变速箱')
INSERT INTO supplier VALUES (5, N'爱德克斯', N'日本', 4, '444-12112233', 425000.0, N'刹车')
INSERT INTO supplier VALUES (6, N'克虏伯', N'德国', 5, '222-3312112233', 225000.0, N'减震器')
INSERT INTO supplier VALUES (7, N'博世', N'德国', 5, '222-1112112233', 4225000.0, N'转向系统')
INSERT INTO supplier VALUES (8, N'博格华纳', N'美国', 3, '333-442112233', 1225000.0, N'四驱系统')
INSERT INTO supplier VALUES (9, N'霍尼韦尔', N'美国', 3, '333-222112233', 1225000.0, N'涡轮增压器')


-- part
-- partkey，name，mfgr，brand，type，size，container，retailprice，comment
INSERT INTO part VALUES (1, N'发动机总成', N'中国奇瑞', N'奇瑞', 'chery1', 86, N'简装', 30, N'质量优秀')
INSERT INTO part VALUES (2, N'发动机总成', N'中国吉利', N'奇瑞', 'geely1', 86, N'简装', 100, N'质量优秀')
INSERT INTO part VALUES (3, N'发动机总成', N'中国比亚迪', N'奇瑞', 'byd-1', 86, N'简装', 100, N'质量优秀')
INSERT INTO part VALUES (4, N'变速箱', N'日本爱信', N'爱信', 'aisin-1', 90, N'简装', 80, N'质量可靠')
INSERT INTO part VALUES (5, N'变速箱', N'德国博世', N'博世', 'bochs-1', 70, N'精装', 90, N'质量可靠')
INSERT INTO part VALUES (6, N'刹车', N'日本爱德克斯', N'爱德克斯', 'aidekesi-1', 76, N'简装', 50, '')
INSERT INTO part VALUES (7, N'减震器', N'德国克虏伯', N'克虏伯', 'kelubo-1', 66, N'简装', 60, '')
INSERT INTO part VALUES (8, N'转向系统', N'德国克虏伯', N'克虏伯', 'kelubo-2', 96, N'精装', 70, '')
INSERT INTO part VALUES (9, N'四驱系统', N'美国博格华纳', N'博格华纳', 'bokhana-1', 96, N'精装', 80, '')
INSERT INTO part VALUES (10, N'涡轮增压器', N'美国霍尼韦尔', N'霍尼韦尔', 'huoniwer-1', 96, N'精装', 40, '')


-- partsupp
-- partkey,suppkey,availqty,supplycost,comment
INSERT INTO partsupp VALUES (1, 1, 500, 50.0, N'奇瑞供应的发动机总成-共500可用-价格50')
INSERT INTO partsupp VALUES (2, 2, 600, 60.0, N'吉利供应的发动机总成-共600可用-价格60')
INSERT INTO partsupp VALUES (3, 3, 700, 70.0, N'比亚迪供应的发动机总成-共700可用-价格70')
INSERT INTO partsupp VALUES (4, 4, 1000, 50.0, N'爱信供应的变速箱-共1000可用-价格50')
INSERT INTO partsupp VALUES (5, 7, 500, 50.0, N'博世供应的变速箱-共500可用-价格50')
INSERT INTO partsupp VALUES (6, 5, 700, 10.0, N'爱德克斯供应的刹车系统-共700可用-价格10')
INSERT INTO partsupp VALUES (7, 6, 1200, 50.0, N'克虏伯供应的减震器-共500可用-价格20')
INSERT INTO partsupp VALUES (8, 6, 500, 20.0, N'克虏伯供应的转向系统-共500可用-价格20')
INSERT INTO partsupp VALUES (9, 8, 1400, 20.0, N'博格华纳供应的四驱系统-共1400可用-价格20')
INSERT INTO partsupp VALUES (10, 9, 1300, 50.0, N'霍尼韦尔供应的涡轮增压器-共1300可用-价格50')

-- customer
-- custkey，name，address，nationkey，phone，acctbal，mktsegment，comment
INSERT INTO customer VALUES (1, N'张三', N'中国北京', 1, '010-1122033', 10000000.0, N'亚洲大区', N'中国买家1')
INSERT INTO customer VALUES (2, N'李四', N'中国北京', 1, '010-2233233', 50000000.0, N'亚洲大区', N'中国买家2')
INSERT INTO customer VALUES (3, N'犬养太郎', N'日本东京', 4, '444-2233233', 400000.0, N'亚洲大区', N'日本买家1')
INSERT INTO customer VALUES (4, N'松下幸', N'日本北海道', 4, '444-11113233', 120000000.0, N'亚洲大区', N'日本买家2')
INSERT INTO customer VALUES (5, N'山姆大叔', N'美国加州', 3, '222-2233233', 23000000.0, N'北美大区', N'美国买家1')
INSERT INTO customer VALUES (6, N'汤姆', N'美国华盛顿', 3, '222-1133233', 1230000.0, N'北美大区', N'美国买家2')
INSERT INTO customer VALUES (7, N'汉斯', N'德国柏林', 5, '555-1122033', 234000000.0, N'欧洲', N'德国买家1')
INSERT INTO customer VALUES (8, N'弗雷德', N'德国汉堡', 5, '555-5552033', 666000000.0, N'欧洲', N'德国买家2')


-- orders
-- orderkey，custkey，orderstatus，totalprice，orderdate，orderpriority，clert，shippriority，comment
INSERT INTO orders VALUES (1, 1, 0, 1000.0, '2020-07-31', N'优先', N'记账员甲', 1, N'张三的订单1')
INSERT INTO orders VALUES (2, 1, 1, 2000.0, '2020-07-31', N'优先', N'记账员乙', 1, N'张三的订单2')
INSERT INTO orders VALUES (3, 1, 2, 3000.0, '2020-07-31', N'优先', N'记账员丙', 1, N'张三的订单3')
INSERT INTO orders VALUES (4, 2, 1, 4000.0, '2020-08-31', N'优先', N'记账员甲', 1, N'李四的订单1')
INSERT INTO orders VALUES (5, 2, 1, 2000.0, '2020-07-31', N'优先', N'记账员乙', 1, N'李四的订单2')
INSERT INTO orders VALUES (6, 2, 2, 1000.0, '2020-06-30', N'优先', N'记账员丙', 1, N'李四的订单3')
INSERT INTO orders VALUES (7, 5, 0, 10000.0, '2020-07-31', N'优先', N'记账员甲', 1, N'山姆大叔的订单')
INSERT INTO orders VALUES (8, 6, 0, 6000.0, '2020-07-31', N'优先', N'记账员丙', 1, N'汤姆的订单')
INSERT INTO orders VALUES (9, 7, 0, 6000.0, '2020-07-31', N'优先', N'记账员丙', 1, N'汉斯的订单')
INSERT INTO orders VALUES (10, 8, 0, 7000.0, '2020-05-31', N'优先', N'记账员丙', 1, N'弗雷德的订单1')
INSERT INTO orders VALUES (11, 8, 0, 1000.0, '2020-07-31', N'优先', N'记账员甲', 1, N'弗雷德的订单2')
INSERT INTO orders VALUES (12, 8, 1, 2000.0, '2020-07-31', N'优先', N'记账员乙', 1, N'弗雷德的订单3')
INSERT INTO orders VALUES (13, 8, 2, 3000.0, '2020-07-31', N'优先', N'记账员丙', 1, N'弗雷德的订单4')
INSERT INTO orders VALUES (14, 1, 0, 40000.0, '2020-08-2', N'优先', N'记账员甲', 1, N'张三的订单4')
INSERT INTO orders VALUES (15, 2, 2, 43000.0, '2020-06-25', N'优先', N'记账员丁', 1, N'李四的订单4')

-- lineitem
-- orderkey，partkey，suppkey，linenumber，quantity，extendedprice，discount，tax，returnflag，linestatus，shipdate，commitdate，receipdate，shipinstruct，shipmodel，comment
INSERT INTO lineitem VALUES (1, 1, 1, 10001, 50.0, 15000.0, 0.1, 0.2, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'空运', N'奇瑞供应给张三的发动机订单')
INSERT INTO lineitem VALUES (2, 2, 2, 10002, 50.0, 15000.0, 0.05, 0.22, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'陆运', N'吉利供应给张三的发动机订单')
INSERT INTO lineitem VALUES (3, 3, 3, 10003, 40.0, 15000.0, 0.05, 0.22, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'比亚迪供应给张三的发动机订单')
INSERT INTO lineitem VALUES (4, 5, 7, 10004, 50.0, 15000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'空运', N'博世供应给李四的变速箱订单')
INSERT INTO lineitem VALUES (5, 1, 1, 10005, 30.0, 12000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'空运', N'奇瑞供应给李四的发动机订单')
INSERT INTO lineitem VALUES (6, 7, 6, 10006, 20.0, 14000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'克虏伯供应给李四的减震器')
INSERT INTO lineitem VALUES (7, 10, 9, 10007, 20.0, 14000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'霍尼韦尔供应给山姆大叔的涡轮增压器')
INSERT INTO lineitem VALUES (8, 9, 8, 10008, 20.0, 14000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'博格华纳供应给汤姆的四驱系统')
INSERT INTO lineitem VALUES (9, 6, 5, 10009, 20.0, 14000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'爱德克斯供应给汉斯的刹车系统')
INSERT INTO lineitem VALUES (10, 4, 4, 10010, 20.0, 14000.0, 0.11, 0.24, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'爱信供应给弗雷德的变速箱')
INSERT INTO lineitem VALUES (11, 1, 1, 10011, 50.0, 15000.0, 0.1, 0.2, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'空运', N'奇瑞供应给弗雷德的发动机订单')
INSERT INTO lineitem VALUES (12, 2, 2, 10012, 50.0, 15000.0, 0.05, 0.22, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'陆运', N'吉利供应给弗雷德的发动机订单')
INSERT INTO lineitem VALUES (13, 3, 3, 10013, 40.0, 15000.0, 0.05, 0.22, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'比亚迪供应给弗雷德的发动机订单')
INSERT INTO lineitem VALUES (14, 3, 3, 10014, 40.0, 15000.0, 0.05, 0.22, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'比亚迪供应给张三的发动机订单2')
INSERT INTO lineitem VALUES (15, 3, 3, 10015, 40.0, 15000.0, 0.05, 0.22, '0', '1', '2020-1-2', '2020-1-2', '2020-1-2', N'装运说明', N'海运', N'比亚迪供应给李四的发动机订单2')
